package intermediate.frame;

import intermediate.Temp;

/**
 * Beschreibt ein Aktivierungsegment whrend der Laufzeit. Aktivierungssegmente haben einen
 * statischen und einen dynamischen Link sowie eine Rcksprungadresse. Auerdem wird diese Klasse
 * verwendet, um whrend der Zwischencodeerstellung zu erfragen, wie die Wortgre ist und wieviele
 * reservierte Felder es in jedem Aktivierungssegment gibt.
 */

public abstract class Frame {


    public static final int STATIC_LINK = 0;
    public static final int DYNAMIC_LINK = 1;
    public static final int RETURN_ADDRESS = 2;

    /**
     * Liefert das Temp zurck, das den Framepointer enthlt
     */
    public abstract Temp fp();

    /**
     * Liefert die Wortgre zurck (gewhnlich 2 (16bit), 4 (32bit) oder 8(64bit)
     */
    public abstract int wordSize();

    /**
     * Liefert den Level des Aktivierungssegmentes zurck. Der Level ist die Schachtelungstiefe
     * des zugehrigen Gltigkeitsbereichs. Sie wird bentigt, um whrend der Laufzeit die statischen
     * Links korrekt aufzubauen.
     */
    public abstract int level();

    public int getMinOffset() {
        return 3;
    };


}
